"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class Base {
    constructor(app = {}, options = {}) {
        this.app = app;
        this.log = app.log;
        this.config = app.config;
        this.options = options;
        this.app.log.warn(`${this.getName()} - magnet-core/base is depreciated, extend magnet-core/module instead`);
    }
    getName() {
        return this.constructor.name;
    }
    setConfig(ns, dConfig) {
        return Object.assign(dConfig, this.config[ns], this.options);
    }
    setup() {
        return __awaiter(this, void 0, void 0, function* () {
            this.app.log.warn(`Module ${this.getName()} missing setup function`);
        });
    }
    teardown() {
        return __awaiter(this, void 0, void 0, function* () { });
    }
}
exports.default = Base;
//# sourceMappingURL=base.js.map